Name:			nut
Version:		0.45.4
Release:		1mdk
License:		GPL

Group:			System/Configuration/Hardware
Summary:		Multi-vendor UPS Monitoring Project Client Utilities
Source:			http://www.exploits.org/nut/release/%{name}-%{version}.tar.gz
Patch0:			nut-0.45.4-mancgi.patch.bz2
Patch1:			nut-0.45.4-hidups.patch.bz2
Patch2:			nut-0.45.4-upsmon-reload.patch.bz2
Patch3:			nut-0.45.4-upsmonconf.patch.bz2
URL:			http://www.exploits.org/nut

BuildRoot:		%{_tmppath}/%{name}-%{version}-root
Prereq:			chkconfig fileutils
BuildPrereq:		libpng3-devel zlib1-devel autoconf /usr/include/linux/hiddev.h

%define STATEPATH  	/var/state/ups
%define CGIPATH   	/var/www/cgi-bin
%define MODELPATH	/sbin
%define CONFPATH	%{_sysconfdir}/ups

%description
These programs are part of a developing project to monitor the assortment 
of UPSes that are found out there in the field. Many models have serial 
ports of some kind that allow some form of state checking. This
capability has been harnessed where possible to allow for safe shutdowns, 
live status tracking on web pages, and more.

This package includes the client utilities that are required to monitor a
UPS that the client host is powered from - either connected directly via
a serial port (in which case the main nut package needs to be installed on
this machine) or across the network (where another host on the network
monitors the UPS via serial cable and runs the main nut package to allow
clients to see the information).

%package	server
Summary:	Multi-vendor UPS Monitoring Project server
Group:		System/Servers
Requires:	nut = %{version} kernel >= 2.4.13

%description	server
These programs are part of a developing project to monitor the assortment 
of UPSes that are found out there in the field. Many models have serial 
serial ports of some kind that allow some form of state checking. This
capability has been harnessed where possible to allow for safe shutdowns, 
live status tracking on web pages, and more.

This package is the main NUT upsd daemon and the associated per-UPS-model
drivers which talk to the UPSes.  You also need to install the base NUT
package.

%package	cgi
Group:		Monitoring
Summary:	CGI utils for Multi-vendor UPS Monitoring Project
Requires:	libgd1 >= 1.6
BuildRequires:	libgd1-devel >= 1.6, libpng-devel

%description	cgi
These programs are part of a developing project to monitor the assortment 
of UPSes that are found out there in the field. Many models have serial 
serial ports of some kind that allow some form of state checking. This
capability has been harnessed where possible to allow for safe shutdowns, 
live status tracking on web pages, and more.

This package adds the web CGI programs.   These can be installed on a
separate machine to the rest of the NUT package.


%prep
%setup -q
# Add a the hosts.conf and CGI man page in the Makefile - install
%patch0 -p1 -b .man
# Add the experimental hidups for USB drivers using 
%patch1 -p1 -b .usb
# Add the reload entry in the upsmon init script
%patch2 -p1 -b .init
# Configure upsmon to start using the user ups by default
%patch3 -p1 -b .conf
autoconf

%build
%serverbuild
CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=/usr \
	--exec-prefix=/usr \
	--sysconfdir=%{CONFPATH} \
	--with-statepath=%{STATEPATH} \
	--with-modelpath=%{MODELPATH} \
	--with-cgipath=%{CGIPATH} \
	--with-user=ups \
	--mandir=%{_mandir} \
	--with-group=ups
%make

%install
rm -rf %{buildroot}
#
# Build basic directories here - if they exist already then the
# installer doesn't try to create and chown them (the chown is
# a killer if we are building as non-root
mkdir -p %{buildroot}%{CONFPATH}
mkdir -p %{buildroot}%{MODELPATH}
mkdir -p %{buildroot}%{CGIPATH}
mkdir -p %{buildroot}%{STATEPATH}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
make INSTALLROOT=%{buildroot} install
make INSTALLROOT=%{buildroot} install-cgi

# Mandrake config  VERIFIER LES DROITS SUR CES FICHIERS:
#mkdir -p %{buildroot}%{_sysconfdir}/sysconfig

# install SYSV init stuff
mkdir -p %{buildroot}%{_initrddir}
install scripts/RedHat-6.0/upsd %{buildroot}/%{_initrddir}
install scripts/RedHat-6.0/upsmon %{buildroot}/%{_initrddir}
install scripts/RedHat-6.0/upspowerdown.rh7 %{buildroot}%{_initrddir}/upspowerdown

mv %{buildroot}%{CONFPATH}/hosts.conf.sample %{buildroot}/%{CONFPATH}/hosts.conf
mv %{buildroot}%{CONFPATH}/multimon.conf.sample %{buildroot}/%{CONFPATH}/multimon.conf
mv %{buildroot}%{CONFPATH}/upsd.conf.sample %{buildroot}/%{CONFPATH}/upsd.conf
mv %{buildroot}%{CONFPATH}/upsd.users.sample %{buildroot}/%{CONFPATH}/upsd.users
mv %{buildroot}%{CONFPATH}/upsmon.conf.sample %{buildroot}/%{CONFPATH}/upsmon.conf
mv %{buildroot}%{CONFPATH}/upssched.conf.sample %{buildroot}/%{CONFPATH}/upssched.conf
mv %{buildroot}%{CONFPATH}/upsset.conf.sample %{buildroot}/%{CONFPATH}/upsset.conf
mv %{buildroot}%{CONFPATH}/ups.conf.sample %{buildroot}/%{CONFPATH}/ups.conf


%pre
# Create an UPS user. 
groupadd -r ups >/dev/null 2>&1 || :
useradd -M -r -g ups -d %{STATEPATH} -s "" -c "UPSD Daemon" -G tty,usb ups 2> /dev/null || true

%preun
# only do this if it is not an upgrade
%_preun_service upsmon
if [ $1 -eq 0 ]
then 
   /sbin/chkconfig --del upsmon
   [ -f %{_initrddir}/upsmon ] && \
   	%{_initrddir}/upsmon stop
fi

%post
%_post_service upsmon
#/sbin/chkconfig --add upsmon
# restart server if this is an upgrade
if [ $1 -gt 1 ]
then
   [ -f %{_initrddir}/upsmon ] && \
   	%{_initrddir}/upsmon restart
fi

%postun
# only do this if it is not an upgrade
if [ $1 -eq 0 ]
then
   userdel ups >/dev/null 2>&1 || :
   groupdel ups >/dev/null 2>&1 || :   
fi


%preun server
# only do this if it is not an upgrade
%_preun_service upsd
%_preun_service upspowerdown
if [ $1 -eq 0 ]
then 
   /sbin/chkconfig --del upspowerdown
   /sbin/chkconfig --del upsd
   [ -f %{_initrddir}/upsd ] && \
   	%{_initrddir}/upsd stop
fi

%post server
%_post_service upsd
%_post_service upspowerdown
/sbin/chkconfig --add upsd
/sbin/chkconfig --add upspowerdown
# restart server if this is an upgrade
if [ $1 -gt 1 ]
then
   [ -f %{_initrddir}/upsd ] && \
   	%{_initrddir}/upsd restart
fi

%clean
rm -rf %{buildroot}

%files server
%defattr(-,root,root)
%{MODELPATH}/*
%_sbindir/upsd
%config(noreplace) %attr(755,root,root) %{_initrddir}/upspowerdown
%config(noreplace) %attr(755,root,root) %{_initrddir}/upsd
%config(noreplace) %attr(644,root,root) %{CONFPATH}/ups.conf
%config(noreplace) %attr(600,root,root) %{CONFPATH}/upsd.conf
%config(noreplace) %attr(600,root,root) %{CONFPATH}/upsd.users
%{_mandir}/man5/ups.conf.5.bz2
%{_mandir}/man5/upsd.conf.5.bz2
%{_mandir}/man5/upsd.users.5.bz2
%{_mandir}/man8/apcsmart.8.bz2
%{_mandir}/man8/belkin.8.bz2
%{_mandir}/man8/bestups.8.bz2
%{_mandir}/man8/fentonups.8.bz2
%{_mandir}/man8/newapc.8.bz2
%{_mandir}/man8/newvictron.8.bz2
%{_mandir}/man8/nutupsdrv.8.bz2
%{_mandir}/man8/powercom.8.bz2
%{_mandir}/man8/upsd.8.bz2
%{_mandir}/man8/upsdrvctl.8.bz2


%files
%defattr(-,root,root)
%doc CHANGES COPYING CREDITS INSTALL README docs/*
%dir %{CONFPATH}
%config(noreplace) %attr(755,root,root) %{_initrddir}/upsmon
%config(noreplace) %attr(644,root,root) %{CONFPATH}/upssched.conf
%config(noreplace) %attr(640,root,ups) %{CONFPATH}/upsmon.conf
%dir %attr(755,ups,ups) %{STATEPATH}
%_bindir/upsc
%_bindir/upscmd
%_bindir/upsct
%_bindir/upsct2
%_bindir/upslog
%_sbindir/upsmon
%_sbindir/upssched
%{_mandir}/man5/upsmon.conf.5.bz2
%{_mandir}/man5/upssched.conf.5.bz2
%{_mandir}/man8/nutupsdrv.8.bz2
%{_mandir}/man8/upsc.8.bz2
%{_mandir}/man8/upscmd.8.bz2
%{_mandir}/man8/upsct.8.bz2
%{_mandir}/man8/upsct2.8.bz2
%{_mandir}/man8/upslog.8.bz2
%{_mandir}/man8/upsmon.8.bz2
%{_mandir}/man8/upssched.8.bz2

%files cgi
%defattr(-,root,root)
%config(noreplace) %attr(644,root,root) %{CONFPATH}/multimon.conf
%config(noreplace) %attr(644,root,root) %{CONFPATH}/hosts.conf
%config(noreplace) %attr(600,ups,root) %{CONFPATH}/upsset.conf
%dir %{CGIPATH}
%{CGIPATH}/*.cgi
%{_mandir}/man5/hosts.conf.5.bz2
%{_mandir}/man8/upsstats.cgi.8.bz2
%{_mandir}/man8/upsset.cgi.8.bz2


%changelog
* Mon Feb 26 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 0.45.4-1mdk
- New release - Add upspowerdown init script and a few man pages

* Wed Feb 07 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 0.45.3-2mdk
- Specfile adaptations for Mandrake Linux.

* Wed Oct 24 2001 Peter Bieringer <pb@bieringer.de> (0.45.3pre1)
- Take man path given by rpm instead of hardwired
- Add some missing man pages to %files

* Wed Feb 07 2001 Karl O. Pinc <kop@meme.com> (0.44.3-pre2)
- Cgi package buildrequires gd >= 1.6
- Added man pages for apcsmart and powercom models

* Tue Dec 05 2000 <Nigel.Metheringham@InTechnology.co.uk> (0.44.2)
- Made cgi package standalone (needs no other parts of NUT)
- Moved some configs into cgi
- Shared hosts.conf between cgi & main

* Fri Nov 24 2000 <Nigel.Metheringham@InTechnology.co.uk> (0.44.2)
- Moved models to be more FHS compliant and make sure they are there
  if everything but root is unmounted
- Moved a few things around

* Mon Aug 21 2000 <Nigel.Metheringham@Vdata.co.uk> (0.44.1)
- Added new model drivers into rpm list
- Made it wildcard more stuff so this doesn't need to be
  maintained for every little change.
  ** NOTE this breaks things if modelpath isn't distinct **

* Mon Jul 17 2000 <Nigel.Metheringham@Vdata.co.uk> (0.44.0)
- Fixed some problems in the spec file
- Dropped the older changelog entries since there is some
  intermediate history thats been missed.
- Added new model drivers into rpm list
- Updated descriptions somewhat

